#include "StyleLexers.h"

// ----------------------------------------------------------------------------

KEYWORDLIST KeyWords_CS =
{
    // Primary keywords
    "abstract as base bool break byte case catch char checked class const continue "
    "decimal default delegate do double else enum event explicit extern "
    "false finally fixed float for foreach goto if implicit in int interface internal is "
    "lock long namespace new null object operator out override params private protected public "
    "readonly record ref return sbyte sealed short sizeof stackalloc static string struct switch "
    "this throw true try typeof uint ulong unchecked unsafe ushort using virtual void volatile while",
    // Secondary keywords
    "add alias ascending async await by descending dynamic equals from get global group init into join let nameof "
    "nint notnull nuint on orderby partial remove select set unmanaged value var when where with yield", 
    // Documentation comment keywords
    "addindex addtogroup anchor arg attention author b brief bug c class code copyright date def defgroup deprecated dontinclude "
    "e em endcode endhtmlonly endif endlatexonly endlink endverbatim enum example exception f$ f[f] file"
    "hideinitializer htmlinclude htmlonly if image include ingroup internal invariant interface latexonly li line link "
    "mainpage name namespace nosubgrouping note overload p page par param param[in] param[out] post pre "
    "ref relates remarks return retval sa section see showinitializer since skip skipline struct subsection "
    "test throw throws todo typedef union until var verbatim verbinclude version warning weakgroup",
    // Global classes and typedefs
    "CriticalHandleMinusOneIsInvalid CriticalHandleZeroOrMinusOneIsInvalid SafeFileHandle SafeHandleMinusOneIsInvalid SafeHandleZeroOrMinusOneIsInvalid "
    "SafeMemoryMappedFileHandle SafeMemoryMappedViewHandle SafePipeHandle SafeProcessHandle SafeWaitHandle SafeX509ChainHandle "
    "AccessViolationException Action Activator AggregateException AppContext AppDomain AppDomainUnloadedException ApplicationException "
    "ApplicationId ArgumentException ArgumentNullException ArgumentOutOfRangeException ArithmeticException Array ArraySegment "
    "Enumerator ArrayTypeMismatchException AssemblyLoadEventArgs AssemblyLoadEventHandler AsyncCallback Attribute AttributeTargets "
    "AttributeUsage AttributeUsageAttribute BadImageFormatException Base64FormattingOptions BitConverter Boolean Buffer Byte "
    "CannotUnloadAppDomainException Char CharEnumerator CLSCompliant CLSCompliantAttribute Comparison Console ConsoleCancelEventArgs "
    "ConsoleCancelEventHandler ConsoleColor ConsoleKey ConsoleKeyInfo ConsoleModifiers ConsoleSpecialKey ContextBoundObject "
    "ContextMarshalException ContextStatic ContextStaticAttribute Convert Converter DataMisalignedException DateTime DateTimeKind "
    "DateTimeOffset DayOfWeek DBNull Decimal Delegate DivideByZeroException DllNotFoundException Double DuplicateWaitObjectException "
    "EntryPointNotFoundException Enum Environment SpecialFolder SpecialFolderOption EnvironmentVariableTarget EventArgs EventHandler "
    "Exception ExecutionEngineException FieldAccessException FileStyleUriParser Flags FlagsAttribute FormatException FormattableString "
    "FtpStyleUriParser Func GC GCCollectionMode GCNotificationStatus GenericUriParser GenericUriParserOptions GopherStyleUriParser "
    "Guid HashCode HttpStyleUriParser IAsyncResult ICloneable IComparable IConvertible ICustomFormatter IDisposable IEquatable "
    "IFormatProvider IFormattable IndexOutOfRangeException InsufficientExecutionStackException InsufficientMemoryException "
    "Int16 Int32 Int64 IntPtr InvalidCastException InvalidOperationException InvalidProgramException InvalidTimeZoneException "
    "IObservable IObserver IProgress IServiceProvider Lazy LdapStyleUriParser LoaderOptimization LoaderOptimization LoaderOptimizationAttribute "
    "LocalDataStoreSlot MarshalByRefObject Math MathF MemberAccessException Memory MemoryExtensions MethodAccessException MidpointRounding "
    "MissingFieldException MissingMemberException MissingMethodException ModuleHandle MTAThread MTAThreadAttribute MulticastDelegate "
    "MulticastNotSupportedException NetPipeStyleUriParser NetTcpStyleUriParser NewsStyleUriParser NonSerialized NonSerializedAttribute "
    "NotFiniteNumberException NotImplementedException NotSupportedException Nullable NullReferenceException Object ObjectDisposedException "
    "Obsolete ObsoleteAttribute OperatingSystem OperationCanceledException OutOfMemoryException OverflowException ParamArray "
    "ParamArrayAttribute PlatformID PlatformNotSupportedException Predicate Progress Random RankException ReadOnlyMemory ref "
    "ResolveEventArgs ResolveEventHandler RuntimeArgumentHandle RuntimeFieldHandle RuntimeMethodHandle RuntimeTypeHandle SByte "
    "Serializable SerializableAttribute Single StackOverflowException STAThread STAThreadAttribute String StringComparer StringComparison "
    "StringNormalizationExtensions StringSplitOptions SystemException ThreadStatic ThreadStaticAttribute TimeoutException TimeSpan "
    "TimeZone TimeZoneInfo AdjustmentRule TransitionTime TimeZoneNotFoundException Tuple TupleExtensions Type TypeAccessException "
    "TypeCode TypedReference TypeInitializationException TypeLoadException TypeUnloadedException UInt16 UInt32 UInt64 UIntPtr "
    "UnauthorizedAccessException UnhandledExceptionEventArgs UnhandledExceptionEventHandler Uri UriBuilder UriComponents UriFormat "
    "UriFormatException UriHostNameType UriKind UriParser UriPartial UriTypeConverter ValueTuple ValueType Version Void WeakReference "
    "ArrayPool BuffersExtensions IBufferWriter IMemoryOwner IPinnable MemoryHandle MemoryManager MemoryPool OperationStatus "
    "ReadOnlySpanAction SpanAction StandardFormat BinaryPrimitives Base64 Utf8Formatter Utf8Parser GeneratedCode GeneratedCodeAttribute "
    "IndentedTextWriter ArrayList BitArray CaseInsensitiveComparer CaseInsensitiveHashCodeProvider CollectionBase Comparer "
    "DictionaryBase DictionaryEntry Hashtable ICollection IComparer IDictionary IDictionaryEnumerator IEnumerable IEnumerator "
    "IEqualityComparer IHashCodeProvider IList IStructuralComparable IStructuralEquatable Queue ReadOnlyCollectionBase SortedList "
    "Stack StructuralComparisons BlockingCollection ConcurrentBag ConcurrentDictionary ConcurrentQueue ConcurrentStack EnumerablePartitionerOptions "
    "IProducerConsumerCollection OrderablePartitioner Partitioner CollectionExtensions Dictionary KeyCollection ValueCollection "
    "EqualityComparer HashSet IReadOnlyCollection IReadOnlyDictionary IReadOnlyList ISet KeyNotFoundException KeyValuePair "
    "LinkedList LinkedListNode List SortedDictionary SortedSet Collection KeyedCollection ObservableCollection ReadOnlyCollection "
    "ReadOnlyDictionary ReadOnlyObservableCollection BitVector32 Section CollectionsUtil HybridDictionary INotifyCollectionChanged "
    "IOrderedDictionary ListDictionary NameObjectCollectionBase KeysCollection NameValueCollection NotifyCollectionChangedAction "
    "NotifyCollectionChangedEventArgs NotifyCollectionChangedEventHandler OrderedDictionary StringCollection StringDictionary "
    "StringEnumerator AddingNewEventArgs AddingNewEventHandler AmbientValue AmbientValueAttribute ArrayConverter AsyncCompletedEventArgs "
    "AsyncCompletedEventHandler AsyncOperation AsyncOperationManager AttributeCollection AttributeProvider AttributeProviderAttribute "
    "BackgroundWorker BaseNumberConverter Bindable BindableAttribute BindableSupport BindingDirection BindingList BooleanConverter "
    "Browsable BrowsableAttribute ByteConverter CancelEventArgs CancelEventHandler Category CategoryAttribute CharConverter "
    "CollectionChangeAction CollectionChangeEventArgs CollectionChangeEventHandler CollectionConverter ComplexBindingProperties "
    "ComplexBindingPropertiesAttribute Component ComponentCollection ComponentConverter ComponentEditor ComponentResourceManager "
    "Container ContainerFilterService CultureInfoConverter CustomTypeDescriptor DataErrorsChangedEventArgs DataObject DataObjectAttribute "
    "DataObjectField DataObjectFieldAttribute DataObjectMethod DataObjectMethodAttribute DataObjectMethodType DateTimeConverter "
    "DateTimeOffsetConverter DecimalConverter DefaultBindingProperty DefaultBindingPropertyAttribute DefaultEvent DefaultEventAttribute "
    "DefaultProperty DefaultPropertyAttribute DefaultValue DefaultValueAttribute Description DescriptionAttribute Designer "
    "DesignerAttribute DesignerCategory DesignerCategoryAttribute DesignerSerializationVisibility DesignerSerializationVisibility "
    "DesignerSerializationVisibilityAttribute DesignOnly DesignOnlyAttribute DesignTimeVisible DesignTimeVisibleAttribute DisplayName "
    "DisplayNameAttribute DoubleConverter DoWorkEventArgs DoWorkEventHandler Editor EditorAttribute EditorBrowsable EditorBrowsableAttribute "
    "EditorBrowsableState EnumConverter EventDescriptor EventDescriptorCollection EventHandlerList ExpandableObjectConverter "
    "ExtenderProvidedProperty ExtenderProvidedPropertyAttribute GuidConverter HandledEventArgs HandledEventHandler IBindingList "
    "IBindingListView ICancelAddNew IChangeTracking IComNativeDescriptorHandler IComponent IContainer ICustomTypeDescriptor "
    "IDataErrorInfo IEditableObject IExtenderProvider IIntellisenseBuilder IListSource ImmutableObject ImmutableObjectAttribute "
    "INestedContainer INestedSite Inheritance InheritanceAttribute InheritanceLevel InitializationEvent InitializationEventAttribute "
    "INotifyDataErrorInfo INotifyPropertyChanged INotifyPropertyChanging InstallerType InstallerTypeAttribute InstanceCreationEditor "
    "Int16Converter Int32Converter Int64Converter InvalidAsynchronousStateException InvalidEnumArgumentException IRaiseItemChangedEvents "
    "IRevertibleChangeTracking ISite ISupportInitialize ISupportInitializeNotification ISynchronizeInvoke ITypeDescriptorContext "
    "ITypedList License LicenseContext LicenseException LicenseManager LicenseProvider LicenseProvider LicenseProviderAttribute "
    "LicenseUsageMode LicFileLicenseProvider ListBindable ListBindableAttribute ListChangedEventArgs ListChangedEventHandler "
    "ListChangedType ListSortDescription ListSortDescriptionCollection ListSortDirection Localizable LocalizableAttribute LookupBindingProperties "
    "LookupBindingPropertiesAttribute MarshalByValueComponent MaskedTextProvider MaskedTextResultHint MemberDescriptor MergableProperty "
    "MergablePropertyAttribute MultilineStringConverter NestedContainer NotifyParentProperty NotifyParentPropertyAttribute "
    "NullableConverter ParenthesizePropertyName ParenthesizePropertyNameAttribute PasswordPropertyText PasswordPropertyTextAttribute "
    "ProgressChangedEventArgs ProgressChangedEventHandler PropertyChangedEventArgs PropertyChangedEventHandler PropertyChangingEventArgs "
    "PropertyChangingEventHandler PropertyDescriptor PropertyDescriptorCollection PropertyTab PropertyTabAttribute PropertyTabScope "
    "ProvideProperty ProvidePropertyAttribute ReadOnly ReadOnlyAttribute RecommendedAsConfigurable RecommendedAsConfigurableAttribute "
    "ReferenceConverter RefreshEventArgs RefreshEventHandler RefreshProperties RefreshProperties RefreshPropertiesAttribute "
    "RunInstaller RunInstallerAttribute RunWorkerCompletedEventArgs RunWorkerCompletedEventHandler SByteConverter SettingsBindable "
    "SettingsBindableAttribute SingleConverter StringConverter SyntaxCheck TimeSpanConverter ToolboxItem ToolboxItemAttribute "
    "ToolboxItemFilter ToolboxItemFilterAttribute ToolboxItemFilterType TypeConverter SimplePropertyDescriptor StandardValuesCollection "
    "TypeConverter TypeConverterAttribute TypeDescriptionProvider TypeDescriptionProvider TypeDescriptionProviderAttribute "
    "TypeDescriptor TypeListConverter UInt16Converter UInt32Converter UInt64Converter WarningException Win32Exception ActiveDesignerEventArgs "
    "ActiveDesignerEventHandler CheckoutException CommandID ComponentChangedEventArgs ComponentChangedEventHandler ComponentChangingEventArgs "
    "ComponentChangingEventHandler ComponentEventArgs ComponentEventHandler ComponentRenameEventArgs ComponentRenameEventHandler "
    "DesignerCollection DesignerEventArgs DesignerEventHandler DesignerOptionService DesignerOptionCollection DesignerTransaction "
    "DesignerTransactionCloseEventArgs DesignerTransactionCloseEventHandler DesignerVerb DesignerVerbCollection DesigntimeLicenseContext "
    "DesigntimeLicenseContextSerializer HelpContextType HelpKeyword HelpKeywordAttribute HelpKeywordType IComponentChangeService "
    "IComponentDiscoveryService IComponentInitializer IDesigner IDesignerEventService IDesignerFilter IDesignerHost IDesignerHostTransactionState "
    "IDesignerOptionService IDictionaryService IEventBindingService IExtenderListService IExtenderProviderService IHelpService "
    "IInheritanceService IMenuCommandService IReferenceService IResourceService IRootDesigner ISelectionService IServiceContainer "
    "ITreeDesigner ITypeDescriptorFilterService ITypeDiscoveryService ITypeResolutionService MenuCommand SelectionTypes ServiceContainer "
    "ServiceCreatorCallback StandardCommands StandardToolWindows TypeDescriptionProviderService ViewTechnology ComponentSerializationService "
    "ContextStack DefaultSerializationProvider DefaultSerializationProviderAttribute DesignerLoader DesignerSerializer DesignerSerializerAttribute "
    "IDesignerLoaderHost IDesignerLoaderHost2 IDesignerLoaderService IDesignerSerializationManager IDesignerSerializationProvider "
    "IDesignerSerializationService INameCreationService InstanceDescriptor MemberRelationship MemberRelationshipService ResolveNameEventArgs "
    "ResolveNameEventHandler RootDesignerSerializer RootDesignerSerializerAttribute SerializationStore AssemblyHashAlgorithm "
    "AssemblyVersionCompatibility AcceptRejectRule CommandBehavior CommandType ConflictOption ConnectionState Constraint ConstraintCollection "
    "ConstraintException DataColumn DataColumnChangeEventArgs DataColumnChangeEventHandler DataColumnCollection DataException "
    "DataRelation DataRelationCollection DataRow DataRowAction DataRowBuilder DataRowChangeEventArgs DataRowChangeEventHandler "
    "DataRowCollection DataRowState DataRowVersion DataRowView DataSet DataSetDateTime DataSysDescription DataSysDescriptionAttribute "
    "DataTable DataTableClearEventArgs DataTableClearEventHandler DataTableCollection DataTableNewRowEventArgs DataTableNewRowEventHandler "
    "DataTableReader DataView DataViewManager DataViewRowState DataViewSetting DataViewSettingCollection DBConcurrencyException "
    "DbType DeletedRowInaccessibleException DuplicateNameException EvaluateException FillErrorEventArgs FillErrorEventHandler "
    "ForeignKeyConstraint IColumnMapping IColumnMappingCollection IDataAdapter IDataParameter IDataParameterCollection IDataReader "
    "IDataRecord IDbCommand IDbConnection IDbDataAdapter IDbDataParameter IDbTransaction InRowChangingEventException InternalDataCollectionBase "
    "InvalidConstraintException InvalidExpressionException IsolationLevel ITableMapping ITableMappingCollection KeyRestrictionBehavior "
    "LoadOption MappingType MergeFailedEventArgs MergeFailedEventHandler MissingMappingAction MissingPrimaryKeyException MissingSchemaAction "
    "NoNullAllowedException ParameterDirection PropertyCollection ReadOnlyException RowNotInTableException Rule SchemaSerializationMode "
    "SchemaType SerializationFormat SqlDbType StateChangeEventArgs StateChangeEventHandler StatementCompletedEventArgs StatementCompletedEventHandler "
    "StatementType StrongTypingException SyntaxErrorException UniqueConstraint UpdateRowSource UpdateStatus VersionNotFoundException "
    "XmlReadMode XmlWriteMode CatalogLocation DataAdapter DataColumnMapping DataColumnMappingCollection DataTableMapping DataTableMappingCollection "
    "DbColumn DbCommand DbCommandBuilder DbConnection DbConnectionStringBuilder DbDataAdapter DbDataReader DbDataReaderExtensions "
    "DbDataRecord DbDataSourceEnumerator DbEnumerator DbException DbMetaDataCollectionNames DbMetaDataColumnNames DbParameter "
    "DbParameterCollection DbProviderFactories DbProviderFactory DbProviderSpecificTypeProperty DbProviderSpecificTypePropertyAttribute "
    "DbTransaction GroupByBehavior IDbColumnSchemaGenerator IdentifierCase RowUpdatedEventArgs RowUpdatingEventArgs SchemaTableColumn "
    "SchemaTableOptionalColumn SupportedJoinOperators INullable SqlAlreadyFilledException SqlBinary SqlBoolean SqlByte SqlBytes "
    "SqlChars SqlCompareOptions SqlDateTime SqlDecimal SqlDouble SqlGuid SqlInt16 SqlInt32 SqlInt64 SqlMoney SqlNotFilledException "
    "SqlNullValueException SqlSingle SqlString SqlTruncateException SqlTypeException SqlXml StorageState BooleanSwitch Conditional "
    "ConditionalAttribute CorrelationManager DataReceivedEventArgs DataReceivedEventHandler Debug Debuggable DebuggableAttribute "
    "DebuggingModes Debugger DebuggerBrowsable DebuggerBrowsableAttribute DebuggerBrowsableState DebuggerDisplay DebuggerDisplayAttribute "
    "DebuggerHidden DebuggerHiddenAttribute DebuggerNonUserCode DebuggerNonUserCodeAttribute DebuggerStepperBoundary DebuggerStepperBoundaryAttribute "
    "DebuggerStepThrough DebuggerStepThroughAttribute DebuggerTypeProxy DebuggerTypeProxyAttribute DebuggerVisualizer DebuggerVisualizerAttribute "
    "DefaultTraceListener DelimitedListTraceListener EventTypeFilter FileVersionInfo MonitoringDescription MonitoringDescriptionAttribute "
    "Process ProcessModule ProcessModuleCollection ProcessPriorityClass ProcessStartInfo ProcessThread ProcessThreadCollection "
    "ProcessWindowStyle SourceFilter SourceLevels SourceSwitch StackFrame StackFrameExtensions StackTrace Stopwatch Switch "
    "Switch SwitchAttribute SwitchLevel SwitchLevelAttribute TextWriterTraceListener ThreadPriorityLevel ThreadState ThreadWaitReason "
    "Trace TraceEventCache TraceEventType TraceFilter TraceLevel TraceListener TraceListenerCollection TraceOptions TraceSource "
    "TraceSwitch ExcludeFromCodeCoverage ExcludeFromCodeCoverageAttribute SuppressMessage SuppressMessageAttribute Contract "
    "ContractAbbreviator ContractAbbreviatorAttribute ContractArgumentValidator ContractArgumentValidatorAttribute ContractClass "
    "ContractClassAttribute ContractClassFor ContractClassForAttribute ContractFailedEventArgs ContractFailureKind ContractInvariantMethod "
    "ContractInvariantMethodAttribute ContractOption ContractOptionAttribute ContractPublicPropertyName ContractPublicPropertyNameAttribute "
    "ContractReferenceAssembly ContractReferenceAssemblyAttribute ContractRuntimeIgnored ContractRuntimeIgnoredAttribute ContractVerification "
    "ContractVerificationAttribute Pure PureAttribute ISymbolBinder ISymbolBinder1 ISymbolDocument ISymbolDocumentWriter ISymbolMethod "
    "ISymbolNamespace ISymbolReader ISymbolScope ISymbolVariable ISymbolWriter SymAddressKind SymbolToken SymDocumentType SymLanguageType "
    "SymLanguageVendor EventActivityOptions Event EventAttribute EventChannel EventCommand EventCommandEventArgs EventCounter "
    "EventData EventDataAttribute EventField EventFieldAttribute EventFieldFormat EventFieldTags EventIgnore EventIgnoreAttribute "
    "EventKeywords EventLevel EventListener EventManifestOptions EventOpcode EventSource internal EventSource EventSourceAttribute "
    "EventSourceCreatedEventArgs EventSourceException EventSourceOptions EventSourceSettings EventTags EventTask EventWrittenEventArgs "
    "NonEvent NonEventAttribute Color ColorConverter KnownColor Point PointConverter PointF Rectangle RectangleConverter RectangleF "
    "Size SizeConverter SizeF SizeFConverter BinaryOperationBinder BindingRestrictions CallInfo ConvertBinder CreateInstanceBinder "
    "DeleteIndexBinder DeleteMemberBinder DynamicMetaObject DynamicMetaObjectBinder DynamicObject ExpandoObject GetIndexBinder "
    "GetMemberBinder IDynamicMetaObjectProvider IInvokeOnGetBinder InvokeBinder InvokeMemberBinder SetIndexBinder SetMemberBinder "
    "UnaryOperationBinder Calendar CalendarAlgorithmType CalendarWeekRule CharUnicodeInfo ChineseLunisolarCalendar CompareInfo "
    "CompareOptions CultureInfo CultureNotFoundException CultureTypes DateTimeFormatInfo DateTimeStyles DaylightTime DigitShapes "
    "EastAsianLunisolarCalendar GlobalizationExtensions GregorianCalendar GregorianCalendarTypes HebrewCalendar HijriCalendar "
    "IdnMapping JapaneseCalendar JapaneseLunisolarCalendar JulianCalendar KoreanCalendar KoreanLunisolarCalendar NumberFormatInfo "
    "NumberStyles PersianCalendar RegionInfo SortKey SortVersion StringInfo TaiwanCalendar TaiwanLunisolarCalendar TextElementEnumerator "
    "TextInfo ThaiBuddhistCalendar TimeSpanStyles UmAlQuraCalendar UnicodeCategory BinaryReader BinaryWriter BufferedStream "
    "Directory DirectoryInfo DirectoryNotFoundException DriveInfo DriveNotFoundException DriveType EndOfStreamException EnumerationOptions "
    "ErrorEventArgs ErrorEventHandler File FileAccess FileAttributes FileInfo FileLoadException FileMode FileNotFoundException "
    "FileOptions FileShare FileStream FileSystemEventArgs FileSystemEventHandler FileSystemInfo FileSystemWatcher HandleInheritability "
    "InternalBufferOverflowException InvalidDataException IOException MatchCasing MatchType MemoryStream NotifyFilters Path "
    "PathTooLongException RenamedEventArgs RenamedEventHandler SearchOption SeekOrigin Stream StreamReader StreamWriter StringReader "
    "StringWriter TextReader TextWriter UnmanagedMemoryAccessor UnmanagedMemoryStream WaitForChangedResult WatcherChangeTypes "
    "BrotliDecoder BrotliEncoder BrotliStream CompressionLevel CompressionMode DeflateStream GZipStream ZipArchive ZipArchiveEntry "
    "ZipArchiveMode ZipFile ZipFileExtensions FileSystemEntry FileSystemEnumerable FindPredicate FindTransform FileSystemEnumerator "
    "FileSystemName INormalizeForIsolatedStorage IsolatedStorage IsolatedStorageException IsolatedStorageFile IsolatedStorageFileStream "
    "IsolatedStorageScope MemoryMappedFile MemoryMappedFileAccess MemoryMappedFileOptions MemoryMappedFileRights MemoryMappedViewAccessor "
    "MemoryMappedViewStream AnonymousPipeClientStream AnonymousPipeServerStream NamedPipeClientStream NamedPipeServerStream "
    "PipeDirection PipeOptions PipeStream PipeStreamImpersonationWorker PipeTransmissionMode Enumerable EnumerableExecutor "
    "EnumerableQuery IGrouping ILookup IOrderedEnumerable IOrderedQueryable IQueryable IQueryProvider Lookup OrderedParallelQuery "
    "ParallelEnumerable ParallelExecutionMode ParallelMergeOptions ParallelQuery Queryable BinaryExpression BlockExpression "
    "CatchBlock ConditionalExpression ConstantExpression DebugInfoExpression DefaultExpression DynamicExpression DynamicExpressionVisitor "
    "ElementInit Expression ExpressionType ExpressionVisitor GotoExpression GotoExpressionKind IArgumentProvider IDynamicExpression "
    "IndexExpression InvocationExpression LabelExpression LabelTarget LambdaExpression ListInitExpression LoopExpression MemberAssignment "
    "MemberBinding MemberBindingType MemberExpression MemberInitExpression MemberListBinding MemberMemberBinding MethodCallExpression "
    "NewArrayExpression NewExpression ParameterExpression RuntimeVariablesExpression SwitchCase SwitchExpression SymbolDocumentInfo "
    "TryExpression TypeBinaryExpression UnaryExpression AuthenticationManager AuthenticationSchemes AuthenticationSchemeSelector "
    "Authorization BindIPEndPoint Cookie CookieCollection CookieContainer CookieException CredentialCache DecompressionMethods "
    "Dns DnsEndPoint DownloadDataCompletedEventArgs DownloadDataCompletedEventHandler DownloadProgressChangedEventArgs DownloadProgressChangedEventHandler "
    "DownloadStringCompletedEventArgs DownloadStringCompletedEventHandler EndPoint FileWebRequest FileWebResponse FtpStatusCode "
    "FtpWebRequest FtpWebResponse GlobalProxySelection HttpContinueDelegate HttpListener ExtendedProtectionSelector HttpListenerBasicIdentity "
    "HttpListenerContext HttpListenerException HttpListenerPrefixCollection HttpListenerRequest HttpListenerResponse HttpListenerTimeoutManager "
    "HttpRequestHeader HttpResponseHeader HttpStatusCode HttpVersion HttpWebRequest HttpWebResponse IAuthenticationModule ICredentialPolicy "
    "ICredentials ICredentialsByHost IPAddress IPEndPoint IPHostEntry IWebProxy IWebProxyScript IWebRequestCreate NetworkCredential "
    "OpenReadCompletedEventArgs OpenReadCompletedEventHandler OpenWriteCompletedEventArgs OpenWriteCompletedEventHandler ProtocolViolationException "
    "SecurityProtocolType ServicePoint ServicePointManager SocketAddress TransportContext UploadDataCompletedEventArgs UploadDataCompletedEventHandler "
    "UploadFileCompletedEventArgs UploadFileCompletedEventHandler UploadProgressChangedEventArgs UploadProgressChangedEventHandler "
    "UploadStringCompletedEventArgs UploadStringCompletedEventHandler UploadValuesCompletedEventArgs UploadValuesCompletedEventHandler "
    "WebClient WebException WebExceptionStatus WebHeaderCollection WebProxy WebRequest WebRequestMethods Ftp Http WebResponse "
    "WebUtility HttpCacheAgeControl HttpRequestCacheLevel HttpRequestCachePolicy RequestCacheLevel RequestCachePolicy ByteArrayContent "
    "ClientCertificateOption DelegatingHandler FormUrlEncodedContent HttpClient HttpClientHandler HttpCompletionOption HttpContent "
    "HttpMessageHandler HttpMessageInvoker HttpMethod HttpRequestException HttpRequestMessage HttpResponseMessage MessageProcessingHandler "
    "MultipartContent MultipartFormDataContent ReadOnlyMemoryContent StreamContent StringContent AuthenticationHeaderValue "
    "CacheControlHeaderValue ContentDispositionHeaderValue ContentRangeHeaderValue EntityTagHeaderValue HttpContentHeaders "
    "HttpHeaders HttpHeaderValueCollection HttpRequestHeaders HttpResponseHeaders MediaTypeHeaderValue MediaTypeWithQualityHeaderValue "
    "NameValueHeaderValue NameValueWithParametersHeaderValue ProductHeaderValue ProductInfoHeaderValue RangeConditionHeaderValue "
    "RangeHeaderValue RangeItemHeaderValue RetryConditionHeaderValue StringWithQualityHeaderValue TransferCodingHeaderValue "
    "TransferCodingWithQualityHeaderValue ViaHeaderValue WarningHeaderValue AlternateView AlternateViewCollection Attachment "
    "AttachmentBase AttachmentCollection DeliveryNotificationOptions LinkedResource LinkedResourceCollection MailAddress MailAddressCollection "
    "MailMessage MailPriority SendCompletedEventHandler SmtpClient SmtpDeliveryFormat SmtpDeliveryMethod SmtpException SmtpFailedRecipientException "
    "SmtpFailedRecipientsException SmtpStatusCode ContentDisposition ContentType DispositionTypeNames MediaTypeNames Application "
    "Image Text TransferEncoding DuplicateAddressDetectionState GatewayIPAddressInformation GatewayIPAddressInformationCollection "
    "IcmpV4Statistics IcmpV6Statistics IPAddressCollection IPAddressInformation IPAddressInformationCollection IPGlobalProperties "
    "IPGlobalStatistics IPInterfaceProperties IPInterfaceStatistics IPStatus IPv4InterfaceProperties IPv4InterfaceStatistics "
    "IPv6InterfaceProperties MulticastIPAddressInformation MulticastIPAddressInformationCollection NetBiosNodeType NetworkAddressChangedEventHandler "
    "NetworkAvailabilityChangedEventHandler NetworkAvailabilityEventArgs NetworkChange NetworkInformationException NetworkInterface "
    "NetworkInterfaceComponent NetworkInterfaceType OperationalStatus PhysicalAddress Ping PingCompletedEventArgs PingCompletedEventHandler "
    "PingException PingOptions PingReply PrefixOrigin ScopeLevel SuffixOrigin TcpConnectionInformation TcpState TcpStatistics "
    "UdpStatistics UnicastIPAddressInformation UnicastIPAddressInformationCollection AuthenticatedStream AuthenticationLevel "
    "EncryptionPolicy LocalCertificateSelectionCallback NegotiateStream ProtectionLevel RemoteCertificateValidationCallback "
    "SslPolicyErrors SslStream AddressFamily IOControlCode IPPacketInformation IPProtectionLevel IPv6MulticastOption LingerOption "
    "MulticastOption NetworkStream ProtocolFamily ProtocolType SelectMode SendPacketsElement Socket SocketAsyncEventArgs SocketAsyncOperation "
    "SocketError SocketException SocketFlags SocketInformation SocketInformationOptions SocketOptionLevel SocketOptionName "
    "SocketReceiveFromResult SocketReceiveMessageFromResult SocketShutdown SocketTaskExtensions SocketType TcpClient TcpListener "
    "TransmitFileOptions UdpClient UdpReceiveResult ClientWebSocket ClientWebSocketOptions HttpListenerWebSocketContext ValueWebSocketReceiveResult "
    "WebSocket WebSocketCloseStatus WebSocketContext WebSocketError WebSocketException WebSocketMessageType WebSocketReceiveResult "
    "WebSocketState BigInteger Complex Matrix3x2 Matrix4x4 Plane Quaternion Vector Vector2 Vector3 Vector4 AmbiguousMatchException "
    "Assembly AssemblyAlgorithmId AssemblyAlgorithmIdAttribute AssemblyCompany AssemblyCompanyAttribute AssemblyConfiguration "
    "AssemblyConfigurationAttribute AssemblyContentType AssemblyCopyright AssemblyCopyrightAttribute AssemblyCulture AssemblyCultureAttribute "
    "AssemblyDefaultAlias AssemblyDefaultAliasAttribute AssemblyDelaySign AssemblyDelaySignAttribute AssemblyDescription AssemblyDescriptionAttribute "
    "AssemblyFileVersion AssemblyFileVersionAttribute AssemblyFlags AssemblyFlagsAttribute AssemblyInformationalVersion AssemblyInformationalVersionAttribute "
    "AssemblyKeyFile AssemblyKeyFileAttribute AssemblyKeyName AssemblyKeyNameAttribute AssemblyMetadata AssemblyMetadataAttribute "
    "AssemblyName AssemblyNameFlags AssemblyNameProxy AssemblyProduct AssemblyProductAttribute AssemblySignatureKey AssemblySignatureKeyAttribute "
    "AssemblyTitle AssemblyTitleAttribute AssemblyTrademark AssemblyTrademarkAttribute AssemblyVersion AssemblyVersionAttribute "
    "Binder BindingFlags CallingConventions ConstructorInfo CustomAttributeData CustomAttributeExtensions CustomAttributeFormatException "
    "CustomAttributeNamedArgument CustomAttributeTypedArgument DefaultMember DefaultMemberAttribute DispatchProxy EventAttributes "
    "EventInfo ExceptionHandlingClause ExceptionHandlingClauseOptions FieldAttributes FieldInfo GenericParameterAttributes "
    "ICustomAttributeProvider ImageFileMachine InterfaceMapping IntrospectionExtensions InvalidFilterCriteriaException IReflect "
    "IReflectableType LocalVariableInfo ManifestResourceInfo MemberFilter MemberInfo MemberTypes MethodAttributes MethodBase "
    "MethodBody MethodImplAttributes MethodInfo Missing Module ModuleResolveEventHandler ObfuscateAssembly ObfuscateAssemblyAttribute "
    "Obfuscation ObfuscationAttribute ParameterAttributes ParameterInfo ParameterModifier Pointer PortableExecutableKinds ProcessorArchitecture "
    "PropertyAttributes PropertyInfo ReflectionContext ReflectionTypeLoadException ResourceAttributes ResourceLocation RuntimeReflectionExtensions "
    "StrongNameKeyPair TargetException TargetInvocationException TargetParameterCountException TypeAttributes TypeDelegator "
    "TypeFilter TypeInfo AssemblyBuilder AssemblyBuilderAccess ConstructorBuilder CustomAttributeBuilder DynamicMethod EnumBuilder "
    "EventBuilder FieldBuilder FlowControl GenericTypeParameterBuilder ILGenerator Label LocalBuilder MethodBuilder ModuleBuilder "
    "OpCode OpCodes OpCodeType OperandType PackingSize ParameterBuilder PropertyBuilder SignatureHelper StackBehaviour TypeBuilder "
    "IResourceReader IResourceWriter MissingManifestResourceException MissingSatelliteAssemblyException NeutralResourcesLanguage "
    "NeutralResourcesLanguageAttribute ResourceManager ResourceReader ResourceSet ResourceWriter SatelliteContractVersion SatelliteContractVersionAttribute "
    "UltimateResourceFallbackLocation AssemblyTargetedPatchBand AssemblyTargetedPatchBandAttribute GCLargeObjectHeapCompactionMode "
    "GCLatencyMode GCSettings MemoryFailPoint TargetedPatchingOptOut TargetedPatchingOptOutAttribute AccessedThroughProperty "
    "AccessedThroughPropertyAttribute AsyncMethodBuilder AsyncMethodBuilderAttribute AsyncStateMachine AsyncStateMachineAttribute "
    "AsyncTaskMethodBuilder AsyncValueTaskMethodBuilder AsyncVoidMethodBuilder CallConvCdecl CallConvFastcall CallConvStdcall "
    "CallConvThiscall CallerFilePath CallerFilePathAttribute CallerLineNumber CallerLineNumberAttribute CallerMemberName CallerMemberNameAttribute "
    "CallSite CallSiteBinder CallSiteHelpers CompilationRelaxations CompilationRelaxations CompilationRelaxationsAttribute "
    "CompilerGenerated CompilerGeneratedAttribute CompilerGlobalScope CompilerGlobalScopeAttribute CompilerMarshalOverride "
    "ConditionalWeakTable CreateValueCallback ConfiguredTaskAwaitable ConfiguredTaskAwaiter ConfiguredValueTaskAwaitable ConfiguredValueTaskAwaiter "
    "ContractHelper CustomConstant CustomConstantAttribute DateTimeConstant DateTimeConstantAttribute DebugInfoGenerator DecimalConstant "
    "DecimalConstantAttribute DefaultDependency DefaultDependencyAttribute Dependency DependencyAttribute DisablePrivateReflection "
    "DisablePrivateReflectionAttribute Discardable DiscardableAttribute Dynamic DynamicAttribute Extension ExtensionAttribute "
    "FixedAddressValueType FixedAddressValueTypeAttribute FixedBuffer FixedBufferAttribute FormattableStringFactory HasCopySemantics "
    "HasCopySemanticsAttribute IAsyncStateMachine ICriticalNotifyCompletion IndexerName IndexerNameAttribute INotifyCompletion "
    "InternalsVisibleTo InternalsVisibleToAttribute IRuntimeVariables IsBoxed IsByRefLike IsByRefLikeAttribute IsByValue IsConst "
    "IsCopyConstructed IsExplicitlyDereferenced IsImplicitlyDereferenced IsJitIntrinsic IsLong IsPinned IsReadOnly IsReadOnlyAttribute "
    "IsSignUnspecifiedByte IStrongBox IsUdtReturn IsVolatile IteratorStateMachine IteratorStateMachineAttribute ITuple IUnknownConstant "
    "IUnknownConstantAttribute LoadHint MethodCodeType MethodImpl MethodImplAttribute MethodImplOptions NativeCppClass NativeCppClassAttribute "
    "ReadOnlyCollectionBuilder ReferenceAssembly ReferenceAssemblyAttribute RequiredAttribute RequiredAttributeAttribute RuleCache "
    "RuntimeCompatibility RuntimeCompatibilityAttribute RuntimeFeature RuntimeHelpers CleanupCode TryCode RuntimeWrappedException "
    "ScopelessEnum ScopelessEnumAttribute SpecialName SpecialNameAttribute StateMachine StateMachineAttribute StringFreezing "
    "StringFreezingAttribute StrongBox SuppressIldasm SuppressIldasmAttribute TaskAwaiter TupleElementNames TupleElementNamesAttribute "
    "TypeForwardedFrom TypeForwardedFromAttribute TypeForwardedTo TypeForwardedToAttribute UnsafeValueType UnsafeValueTypeAttribute "
    "ValueTaskAwaiter YieldAwaitable YieldAwaiter Cer Consistency CriticalFinalizerObject PrePrepareMethod PrePrepareMethodAttribute "
    "ReliabilityContract ReliabilityContractAttribute ExceptionDispatchInfo FirstChanceExceptionEventArgs HandleProcessCorruptedStateExceptions "
    "HandleProcessCorruptedStateExceptionsAttribute AllowReversePInvokeCalls AllowReversePInvokeCallsAttribute Architecture "
    "ArrayWithOffset AutomationProxy AutomationProxyAttribute BestFitMapping BestFitMappingAttribute BStrWrapper CallingConvention "
    "CharSet ClassInterface ClassInterfaceAttribute ClassInterfaceType CoClass CoClassAttribute ComAliasName ComAliasNameAttribute "
    "ComAwareEventInfo ComCompatibleVersion ComCompatibleVersionAttribute ComConversionLoss ComConversionLossAttribute ComDefaultInterface "
    "ComDefaultInterfaceAttribute ComEventInterface ComEventInterfaceAttribute ComEventsHelper COMException ComImport ComImportAttribute "
    "ComInterfaceType ComMemberType ComRegisterFunction ComRegisterFunctionAttribute ComSourceInterfaces ComSourceInterfacesAttribute "
    "ComUnregisterFunction ComUnregisterFunctionAttribute ComVisible ComVisibleAttribute CriticalHandle CurrencyWrapper CustomQueryInterfaceMode "
    "CustomQueryInterfaceResult DefaultCharSet DefaultCharSetAttribute DefaultDllImportSearchPaths DefaultDllImportSearchPathsAttribute "
    "DefaultParameterValue DefaultParameterValueAttribute DispatchWrapper DispId DispIdAttribute DllImport DllImportAttribute "
    "DllImportSearchPath ErrorWrapper ExternalException FieldOffset FieldOffsetAttribute GCHandle GCHandleType Guid GuidAttribute "
    "HandleCollector HandleRef ICustomAdapter ICustomFactory ICustomMarshaler ICustomQueryInterface ImportedFromTypeLib ImportedFromTypeLibAttribute "
    "In InAttribute InterfaceType InterfaceTypeAttribute InvalidComObjectException InvalidOleVariantTypeException LayoutKind "
    "LCIDConversion LCIDConversionAttribute ManagedToNativeComInteropStub ManagedToNativeComInteropStubAttribute Marshal MarshalAs "
    "MarshalAsAttribute MarshalDirectiveException MemoryMarshal ReadOnlySpan Span Optional OptionalAttribute OSPlatform Out "
    "OutAttribute PreserveSig PreserveSigAttribute PrimaryInteropAssembly PrimaryInteropAssemblyAttribute ProgId ProgIdAttribute "
    "RuntimeEnvironment RuntimeInformation SafeArrayRankMismatchException SafeArrayTypeMismatchException SafeBuffer SafeHandle "
    "SEHException StructLayout StructLayoutAttribute TypeIdentifier TypeIdentifierAttribute TypeLibFunc TypeLibFuncAttribute "
    "TypeLibFuncFlags TypeLibImportClass TypeLibImportClassAttribute TypeLibType TypeLibTypeAttribute TypeLibTypeFlags TypeLibVar "
    "TypeLibVarAttribute TypeLibVarFlags TypeLibVersion TypeLibVersionAttribute UnknownWrapper UnmanagedFunctionPointer UnmanagedFunctionPointerAttribute "
    "UnmanagedType VarEnum VariantWrapper ADVF BIND_OPTS BINDPTR CALLCONV CONNECTDATA DATADIR DESCKIND DISPPARAMS DVASPECT "
    "ELEMDESC DESCUNION EXCEPINFO FILETIME FORMATETC FUNCDESC FUNCFLAGS FUNCKIND IAdviseSink IBindCtx IConnectionPoint IConnectionPointContainer "
    "IDataObject IDLDESC IDLFLAG IEnumConnectionPoints IEnumConnections IEnumFORMATETC IEnumMoniker IEnumSTATDATA IEnumString "
    "IEnumVARIANT IMoniker IMPLTYPEFLAGS INVOKEKIND IPersistFile IRunningObjectTable IStream ITypeComp ITypeInfo ITypeInfo2 "
    "ITypeLib ITypeLib2 LIBFLAGS PARAMDESC PARAMFLAG STATDATA STATSTG STGMEDIUM SYSKIND TYMED TYPEATTR TYPEDESC TYPEFLAGS TYPEKIND "
    "TYPELIBATTR VARDESC VARFLAGS VARKIND CollectionDataContract CollectionDataContractAttribute ContractNamespace ContractNamespaceAttribute "
    "DataContract DataContractAttribute DataContractResolver DataContractSerializer DataContractSerializerExtensions DataContractSerializerSettings "
    "DataMember DataMemberAttribute DateTimeFormat EmitTypeInformation EnumMember EnumMemberAttribute ExportOptions ExtensionDataObject "
    "Formatter FormatterConverter FormatterServices IDeserializationCallback IExtensibleDataObject IFormatter IFormatterConverter "
    "IgnoreDataMember IgnoreDataMemberAttribute InvalidDataContractException IObjectReference ISafeSerializationData ISerializable "
    "ISerializationSurrogate ISerializationSurrogateProvider ISurrogateSelector KnownType KnownTypeAttribute ObjectIDGenerator "
    "ObjectManager OnDeserialized OnDeserializedAttribute OnDeserializing OnDeserializingAttribute OnSerialized OnSerializedAttribute "
    "OnSerializing OnSerializingAttribute OptionalField OptionalFieldAttribute SafeSerializationEventArgs SerializationBinder "
    "SerializationEntry SerializationException SerializationInfo SerializationInfoEnumerator SerializationObjectManager StreamingContext "
    "StreamingContextStates SurrogateSelector XmlObjectSerializer XmlSerializableServices XPathQueryGenerator XsdDataContractExporter "
    "FormatterAssemblyStyle FormatterTypeStyle IFieldInfo TypeFilterLevel BinaryFormatter DataContractJsonSerializer DataContractJsonSerializerSettings "
    "IXmlJsonReaderInitializer IXmlJsonWriterInitializer JsonReaderWriterFactory ComponentGuarantees ComponentGuaranteesAttribute "
    "ComponentGuaranteesOptions FrameworkName ResourceConsumption ResourceConsumptionAttribute ResourceExposure ResourceExposureAttribute "
    "ResourceScope TargetFramework TargetFrameworkAttribute VersioningHelper AllowPartiallyTrustedCallers AllowPartiallyTrustedCallersAttribute "
    "IPermission ISecurityEncodable PartialTrustVisibilityLevel SecureString SecureStringMarshal SecurityCritical SecurityCriticalAttribute "
    "SecurityCriticalScope SecurityElement SecurityException SecurityRules SecurityRulesAttribute SecurityRuleSet SecuritySafeCritical "
    "SecuritySafeCriticalAttribute SecurityTransparent SecurityTransparentAttribute SecurityTreatAsSafe SecurityTreatAsSafeAttribute "
    "SuppressUnmanagedCodeSecurity SuppressUnmanagedCodeSecurityAttribute UnverifiableCode UnverifiableCodeAttribute VerificationException "
    "AuthenticationException CipherAlgorithmType ExchangeAlgorithmType HashAlgorithmType InvalidCredentialException SslProtocols "
    "ChannelBinding ChannelBindingKind ExtendedProtectionPolicy ExtendedProtectionPolicyTypeConverter PolicyEnforcement ProtectionScenario "
    "ServiceNameCollection Claim ClaimsIdentity ClaimsPrincipal ClaimTypes ClaimValueTypes Aes AesCryptoServiceProvider AesManaged "
    "AsnEncodedData AsnEncodedDataCollection AsnEncodedDataEnumerator AsymmetricAlgorithm AsymmetricKeyExchangeDeformatter "
    "AsymmetricKeyExchangeFormatter AsymmetricSignatureDeformatter AsymmetricSignatureFormatter CipherMode CryptoConfig CryptographicException "
    "CryptographicOperations CryptographicUnexpectedOperationException CryptoStream CryptoStreamMode CspKeyContainerInfo CspParameters "
    "CspProviderFlags DeriveBytes DES DESCryptoServiceProvider DSA DSACryptoServiceProvider DSAParameters DSASignatureDeformatter "
    "DSASignatureFormatter ECCurve ECCurveType NamedCurves ECDiffieHellman ECDiffieHellmanPublicKey ECDsa ECParameters ECPoint "
    "FromBase64Transform FromBase64TransformMode HashAlgorithm HashAlgorithmName HMAC HMACMD5 HMACSHA1 HMACSHA256 HMACSHA384 "
    "HMACSHA512 ICryptoTransform ICspAsymmetricAlgorithm IncrementalHash KeyedHashAlgorithm KeyNumber KeySizes MaskGenerationMethod "
    "MD5 MD5CryptoServiceProvider Oid OidCollection OidEnumerator OidGroup PaddingMode PasswordDeriveBytes PKCS1MaskGenerationMethod "
    "RandomNumberGenerator RC2 RC2CryptoServiceProvider Rfc2898DeriveBytes Rijndael RijndaelManaged RNGCryptoServiceProvider "
    "RSA RSACryptoServiceProvider RSAEncryptionPadding RSAEncryptionPaddingMode RSAOAEPKeyExchangeDeformatter RSAOAEPKeyExchangeFormatter "
    "RSAParameters RSAPKCS1KeyExchangeDeformatter RSAPKCS1KeyExchangeFormatter RSAPKCS1SignatureDeformatter RSAPKCS1SignatureFormatter "
    "RSASignaturePadding RSASignaturePaddingMode SHA1 SHA1CryptoServiceProvider SHA1Managed SHA256 SHA256CryptoServiceProvider "
    "SHA256Managed SHA384 SHA384CryptoServiceProvider SHA384Managed SHA512 SHA512CryptoServiceProvider SHA512Managed SignatureDescription "
    "SymmetricAlgorithm ToBase64Transform TripleDES TripleDESCryptoServiceProvider CertificateRequest DSACertificateExtensions "
    "ECDsaCertificateExtensions OpenFlags PublicKey RSACertificateExtensions StoreLocation StoreName SubjectAlternativeNameBuilder "
    "X500DistinguishedName X500DistinguishedNameFlags X509BasicConstraintsExtension X509Certificate X509Certificate2 X509Certificate2Collection "
    "X509Certificate2Enumerator X509CertificateCollection X509CertificateEnumerator X509Chain X509ChainElement X509ChainElementCollection "
    "X509ChainElementEnumerator X509ChainPolicy X509ChainStatus X509ChainStatusFlags X509ContentType X509EnhancedKeyUsageExtension "
    "X509Extension X509ExtensionCollection X509ExtensionEnumerator X509FindType X509IncludeOption X509KeyStorageFlags X509KeyUsageExtension "
    "X509KeyUsageFlags X509NameType X509RevocationFlag X509RevocationMode X509SignatureGenerator X509Store X509SubjectKeyIdentifierExtension "
    "X509SubjectKeyIdentifierHashAlgorithm X509VerificationFlags CodeAccessSecurity CodeAccessSecurityAttribute SecurityAction "
    "Security SecurityAttribute SecurityPermission SecurityPermissionAttribute SecurityPermissionFlag GenericIdentity GenericPrincipal "
    "IIdentity IPrincipal PrincipalPolicy TokenImpersonationLevel ASCIIEncoding Decoder DecoderExceptionFallback DecoderExceptionFallbackBuffer "
    "DecoderFallback DecoderFallbackBuffer DecoderFallbackException DecoderReplacementFallback DecoderReplacementFallbackBuffer "
    "Encoder EncoderExceptionFallback EncoderExceptionFallbackBuffer EncoderFallback EncoderFallbackBuffer EncoderFallbackException "
    "EncoderReplacementFallback EncoderReplacementFallbackBuffer Encoding EncodingInfo EncodingProvider NormalizationForm StringBuilder "
    "UnicodeEncoding UTF32Encoding UTF7Encoding UTF8Encoding Capture CaptureCollection Group GroupCollection Match MatchCollection "
    "MatchEvaluator Regex RegexMatchTimeoutException RegexOptions RegexRunner RegexRunnerFactory AbandonedMutexException ApartmentState "
    "AsyncFlowControl AsyncLocal AsyncLocalValueChangedArgs AutoResetEvent Barrier BarrierPostPhaseException CancellationToken "
    "CancellationTokenRegistration CancellationTokenSource CompressedStack ContextCallback CountdownEvent EventResetMode EventWaitHandle "
    "ExecutionContext HostExecutionContext HostExecutionContextManager Interlocked void LazyInitializer LazyThreadSafetyMode "
    "LockCookie LockRecursionException LockRecursionPolicy ManualResetEvent ManualResetEventSlim Monitor Mutex NativeOverlapped "
    "Overlapped ParameterizedThreadStart PreAllocatedOverlapped ReaderWriterLock ReaderWriterLockSlim RegisteredWaitHandle "
    "Semaphore SemaphoreFullException SemaphoreSlim SendOrPostCallback SpinLock SpinWait SynchronizationContext SynchronizationLockException "
    "Thread ThreadAbortException ThreadExceptionEventArgs ThreadExceptionEventHandler ThreadInterruptedException ThreadLocal "
    "ThreadPool ThreadPoolBoundHandle ThreadPriority ThreadStart ThreadStartException ThreadStateException Timeout Timer TimerCallback "
    "Volatile WaitCallback WaitHandle WaitHandleCannotBeOpenedException WaitHandleExtensions WaitOrTimerCallback ConcurrentExclusiveSchedulerPair "
    "Parallel ParallelLoopResult ParallelLoopState ParallelOptions Task TaskCanceledException TaskCompletionSource TaskContinuationOptions "
    "TaskCreationOptions TaskExtensions TaskFactory TaskScheduler TaskSchedulerException TaskStatus UnobservedTaskExceptionEventArgs "
    "ValueTask IValueTaskSource ValueTaskSourceOnCompletedFlags ValueTaskSourceStatus ElapsedEventArgs ElapsedEventHandler "
    "TimersDescription TimersDescriptionAttribute CommittableTransaction DependentCloneOption DependentTransaction Enlistment "
    "EnlistmentOptions EnterpriseServicesInteropOption HostCurrentTransactionCallback IDtcTransaction IEnlistmentNotification "
    "IPromotableSinglePhaseNotification ISimpleTransactionSuperior ISinglePhaseNotification ITransactionPromoter PreparingEnlistment "
    "SinglePhaseEnlistment SubordinateTransaction Transaction TransactionAbortedException TransactionCompletedEventHandler "
    "TransactionEventArgs TransactionException TransactionInDoubtException TransactionInformation TransactionInterop TransactionManager "
    "TransactionManagerCommunicationException TransactionOptions TransactionPromotionException TransactionScope TransactionScopeAsyncFlowOption "
    "TransactionScopeOption TransactionStartedEventHandler TransactionStatus HttpUtility ICommand ConformanceLevel DtdProcessing "
    "EntityHandling Formatting IFragmentCapableXmlDictionaryWriter IHasXmlNode IStreamProvider IXmlBinaryReaderInitializer "
    "IXmlBinaryWriterInitializer IXmlDictionary IXmlLineInfo IXmlNamespaceResolver IXmlTextReaderInitializer IXmlTextWriterInitializer "
    "NamespaceHandling NameTable NewLineHandling OnXmlDictionaryReaderClose ReadState UniqueId ValidationType WhitespaceHandling "
    "WriteState Xml XmlAttribute XmlAttributeCollection XmlBinaryReaderSession XmlBinaryWriterSession XmlCDataSection XmlCharacterData "
    "XmlComment XmlConvert XmlDateTimeSerializationMode XmlDeclaration XmlDictionary XmlDictionaryReader XmlDictionaryReaderQuotas "
    "XmlDictionaryReaderQuotaTypes XmlDictionaryString XmlDictionaryWriter XmlDocument XmlDocumentFragment XmlDocumentType "
    "XmlElement XmlEntity XmlEntityReference XmlException XmlImplementation XmlLinkedNode XmlNamedNodeMap XmlNamespaceManager "
    "XmlNamespaceScope XmlNameTable XmlNode XmlNodeChangedAction XmlNodeChangedEventArgs XmlNodeChangedEventHandler XmlNodeList "
    "XmlNodeOrder XmlNodeReader XmlNodeType XmlNotation XmlOutputMethod XmlParserContext XmlProcessingInstruction XmlQualifiedName "
    "XmlReader XmlReaderSettings XmlResolver XmlSecureResolver XmlSignificantWhitespace XmlSpace XmlText XmlTextReader XmlTextWriter "
    "XmlTokenizedType XmlUrlResolver XmlValidatingReader XmlWhitespace XmlWriter XmlWriterSettings Extensions LoadOptions ReaderOptions "
    "SaveOptions XAttribute XCData XComment XContainer XDeclaration XDocument XDocumentType XElement XName XNamespace XNode "
    "XNodeDocumentOrderComparer XNodeEqualityComparer XObject XObjectChange XObjectChangeEventArgs XProcessingInstruction XStreamingElement "
    "XText XmlKnownDtds XmlPreloadedResolver IXmlSchemaInfo ValidationEventArgs ValidationEventHandler XmlAtomicValue XmlSchema "
    "XmlSchemaAll XmlSchemaAnnotated XmlSchemaAnnotation XmlSchemaAny XmlSchemaAny XmlSchemaAnyAttribute XmlSchemaAppInfo XmlSchema "
    "XmlSchemaAttribute XmlSchemaAttributeGroup XmlSchemaAttributeGroupRef XmlSchemaChoice XmlSchemaCollection XmlSchemaCollectionEnumerator "
    "XmlSchemaCompilationSettings XmlSchemaComplexContent XmlSchemaComplexContentExtension XmlSchemaComplexContentRestriction "
    "XmlSchemaComplexType XmlSchemaContent XmlSchemaContentModel XmlSchemaContentProcessing XmlSchemaContentType XmlSchemaDatatype "
    "XmlSchemaDatatypeVariety XmlSchemaDerivationMethod XmlSchemaDocumentation XmlSchemaElement XmlSchemaEnumerationFacet XmlSchemaException "
    "XmlSchemaExternal XmlSchemaFacet XmlSchemaForm XmlSchemaFractionDigitsFacet XmlSchemaGroup XmlSchemaGroupBase XmlSchemaGroupRef "
    "XmlSchemaIdentityConstraint XmlSchemaImport XmlSchemaInclude XmlSchemaInference InferenceOption XmlSchemaInferenceException "
    "XmlSchemaInfo XmlSchemaKey XmlSchemaKeyref XmlSchemaLengthFacet XmlSchemaMaxExclusiveFacet XmlSchemaMaxInclusiveFacet "
    "XmlSchemaMaxLengthFacet XmlSchemaMinExclusiveFacet XmlSchemaMinInclusiveFacet XmlSchemaMinLengthFacet XmlSchemaNotation "
    "XmlSchemaNumericFacet XmlSchemaObject XmlSchemaObjectCollection XmlSchemaObjectEnumerator XmlSchemaObjectTable XmlSchemaParticle "
    "XmlSchemaPatternFacet XmlSchemaRedefine XmlSchemaSequence XmlSchemaSet XmlSchemaSimpleContent XmlSchemaSimpleContentExtension "
    "XmlSchemaSimpleContentRestriction XmlSchemaSimpleType XmlSchemaSimpleTypeContent XmlSchemaSimpleTypeList XmlSchemaSimpleTypeRestriction "
    "XmlSchemaSimpleTypeUnion XmlSchemaTotalDigitsFacet XmlSchemaType XmlSchemaUnique XmlSchemaUse XmlSchemaValidationException "
    "XmlSchemaValidationFlags XmlSchemaValidator XmlSchemaValidity XmlSchemaWhiteSpaceFacet XmlSchemaXPath XmlSeverityType "
    "XmlTypeCode XmlValueGetter CodeGenerationOptions CodeIdentifier CodeIdentifiers ImportContext IXmlSerializable IXmlTextParser "
    "SchemaImporter SoapAttribute SoapAttributeAttribute SoapAttributeOverrides SoapAttributes SoapElement SoapElementAttribute "
    "SoapEnum SoapEnumAttribute SoapIgnore SoapIgnoreAttribute SoapInclude SoapIncludeAttribute SoapReflectionImporter SoapSchemaMember "
    "SoapType SoapTypeAttribute UnreferencedObjectEventArgs UnreferencedObjectEventHandler XmlAnyAttribute XmlAnyAttributeAttribute "
    "XmlAnyElement XmlAnyElementAttribute XmlAnyElementAttributes XmlArray XmlArrayAttribute XmlArrayItem XmlArrayItemAttribute "
    "XmlArrayItemAttributes XmlAttribute XmlAttributeAttribute XmlAttributeEventArgs XmlAttributeEventHandler XmlAttributeOverrides "
    "XmlAttributes XmlChoiceIdentifier XmlChoiceIdentifierAttribute XmlDeserializationEvents XmlElement XmlElementAttribute "
    "XmlElementAttributes XmlElementEventArgs XmlElementEventHandler XmlEnum XmlEnumAttribute XmlIgnore XmlIgnoreAttribute "
    "XmlInclude XmlIncludeAttribute XmlMapping XmlMappingAccess XmlMemberMapping XmlMembersMapping XmlNamespaceDeclarations "
    "XmlNamespaceDeclarationsAttribute XmlNodeEventArgs XmlNodeEventHandler XmlReflectionImporter XmlReflectionMember XmlRoot "
    "XmlRootAttribute XmlSchemaEnumerator XmlSchemaExporter XmlSchemaImporter XmlSchemaProvider XmlSchemaProviderAttribute "
    "XmlSchemas XmlSerializationCollectionFixupCallback XmlSerializationFixupCallback XmlSerializationGeneratedCode XmlSerializationReadCallback "
    "XmlSerializationReader CollectionFixup Fixup XmlSerializationWriteCallback XmlSerializationWriter XmlSerializer XmlSerializerAssembly "
    "XmlSerializerAssemblyAttribute XmlSerializerFactory XmlSerializerImplementation XmlSerializerNamespaces XmlSerializerVersion "
    "XmlSerializerVersionAttribute XmlText XmlTextAttribute XmlType XmlTypeAttribute XmlTypeMapping IXPathNavigable XDocumentExtensions "
    "XmlCaseOrder XmlDataType XmlSortOrder XPathDocument XPathException XPathExpression XPathItem XPathNamespaceScope XPathNavigator "
    "XPathNodeIterator XPathNodeType XPathResultType IXsltContextFunction IXsltContextVariable XslCompiledTransform XsltArgumentList "
    "XsltCompileException XsltContext XsltException XsltMessageEncounteredEventArgs XsltMessageEncounteredEventHandler XslTransform",
    // Preprocessor definitions
    "DEBUG TRACE nullable NETFRAMEWORK NET48 NET472 NET471 NET47 NET462 NET461 NET46 NET452 NET451 NET45 NET40 NET35 NET20 "
    "NETSTANDARD NETSTANDARD2_1 NETSTANDARD2_0 NETSTANDARD1_6 NETSTANDARD1_5 NETSTANDARD1_4 NETSTANDARD1_3 NETSTANDARD1_2 NETSTANDARD1_1 NETSTANDARD1_0 "
    "NET NET5_0 NETCOREAPP NETCOREAPP3_1 NETCOREAPP3_0 NETCOREAPP2_2 NETCOREAPP2_1 NETCOREAPP2_0 NETCOREAPP1_1 NETCOREAPP1_0",
    // Task marker and error marker keywords
    "BUG FIXME HACK NOTE TBD TODO UNDONE XXX @@@",
    NULL,
};


EDITLEXER lexCS =
{
    SCLEX_CPP, "cpp", IDS_LEX_CSHARP_SRC, L"C# Source Code", L"cs; csx; vala", L"",
    &KeyWords_CS, {
        { {STYLE_DEFAULT}, IDS_LEX_STR_Default, L"Default", L"", L"" },
        //{ {SCE_C_DEFAULT}, IDS_LEX_STR_Default, L"C Default", L"", L"" },
        { {SCE_C_IDENTIFIER}, IDS_LEX_STR_Identifier, L"Identifier", L"", L"" },
        { {MULTI_STYLE(SCE_C_COMMENT,SCE_C_COMMENTLINE,0,0)}, IDS_LEX_STR_Comment, L"Comment", L"fore:#008000", L"" },
        { {SCE_C_WORD}, IDS_LEX_STR_Keyword, L"Keyword", L"bold; fore:#804000", L"" },
        { {SCE_C_WORD2}, IDS_LEX_STR_Keyword2nd, L"Keyword 2nd", L"bold; italic; fore:#804000", L"" },
        { {SCE_C_GLOBALCLASS}, IDS_LEX_STR_GlobClass, L"Global Class", L"fore:#2B91AF", L"" },
        { {SCE_C_STRING}, IDS_LEX_STR_String, L"String", L"fore:#008000", L"" },
        //{ {SCE_C_REGEX}, IDS_LEX_STR_RegEx, L"Regex", L"fore:#006633; back:#FFF1A8", L"" },
        { {SCE_C_NUMBER}, IDS_LEX_STR_Number, L"Number", L"fore:#FF0000", L"" },
        { {SCE_C_OPERATOR}, IDS_LEX_STR_Operator, L"Operator", L"fore:#B000B0", L"" },
        { {MULTI_STYLE(SCE_C_PREPROCESSOR,SCE_C_PREPROCESSORCOMMENT,SCE_C_PREPROCESSORCOMMENTDOC,0)}, IDS_LEX_STR_PreProc, L"Preprocessor", L"fore:#FF8000", L"" },
        { {MULTI_STYLE(SCE_C_VERBATIM,SCE_C_TRIPLEVERBATIM,0,0)}, IDS_LEX_STR_VerbStrg, L"Verbatim String", L"fore:#008000", L"" },
        { {MULTI_STYLE(SCE_C_COMMENTDOC,SCE_C_COMMENTLINEDOC,0,0)}, IDS_LEX_STR_63259, L"Comment Doc", L"fore:#808080", L"" },
        { {SCE_C_COMMENTDOCKEYWORD}, IDS_LEX_STR_63371, L"Comment Doc Word", L"bold; fore:#808080", L"" },
        { {SCE_C_COMMENTDOCKEYWORDERROR}, IDS_LEX_STR_63374, L"Comment Doc Error", L"italic; fore:#800000", L"" },
        { {SCE_C_TASKMARKER}, IDS_LEX_STR_63373, L"Task Marker", L"bold; fore:#208080", L"" },
        //{ {SCE_C_UUID}, L"UUID", L"", L"" },
        //{ {SCE_C_USERLITERAL}, L"User Literal", L"", L"" },
        //{ {SCE_C_ESCAPESEQUENCE}, L"Esc Seq", L"", L"" },
        EDITLEXER_SENTINEL
    }
};
