/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Mozilla Communicator client code.
 *
 * The Initial Developer of the Original Code is
 * Netscape Communications Corporation.
 * Portions created by the Initial Developer are Copyright (C) 1998
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

#include "../nsSBCharSetProber.h"

/********* Language model for: Africaans *********/

/**
 * Generated by BuildLangModel.py
 * On: 2019-03-05 22:07:18.720938
 **/

/* Character Mapping Table:
 * ILL: illegal character.
 * CTR: control character specific to the charset.
 * RET: carriage/return.
 * SYM: symbol (punctuation) that does not belong to word.
 * NUM: 0 - 9.
 *
 * Other characters are ordered by probabilities
 * (0 is the most common character in the language).
 *
 * Orders are generic to a language. So the codepoint with order X in
 * CHARSET1 maps to the same character as the codepoint with the same
 * order X in CHARSET2 for the same language.
 * As such, it is possible to get missing order. For instance the
 * ligature of 'o' and 'e' exists in ISO-8859-15 but not in ISO-8859-1
 * even though they are both used for French. Same for the euro sign.
 */
constexpr unsigned char Windows_1252_CharToOrderMap[] =
{
  CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,RET,CTR,CTR,RET,CTR,CTR, /* 0X */
  CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR, /* 1X */
  SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM, /* 2X */
  NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,SYM,SYM,SYM,SYM,SYM,SYM, /* 3X */
  SYM,  3, 16, 21,  8,  0, 20, 10, 18,  1, 22, 11,  9, 14,  2,  6, /* 4X */
   17, 29,  5,  4,  7, 13, 12, 15, 27, 19, 25,SYM,SYM,SYM,SYM,SYM, /* 5X */
  SYM,  3, 16, 21,  8,  0, 20, 10, 18,  1, 22, 11,  9, 14,  2,  6, /* 6X */
   17, 29,  5,  4,  7, 13, 12, 15, 27, 19, 25,SYM,SYM,SYM,SYM,CTR, /* 7X */
  SYM,ILL,SYM, 53,SYM,SYM,SYM,SYM,SYM,SYM, 32,SYM, 54,ILL, 37,ILL, /* 8X */
  ILL,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM, 32,SYM, 55,ILL, 37, 56, /* 9X */
  SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM, /* AX */
  SYM,SYM,SYM,SYM,SYM, 57,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM, /* BX */
   48, 28, 45, 44, 43, 51, 42, 39, 35, 26, 24, 23, 52, 38, 49, 30, /* CX */
   58, 59, 41, 31, 33, 60, 40,SYM, 36, 50, 61, 47, 34, 62, 63, 46, /* DX */
   48, 28, 45, 44, 43, 51, 42, 39, 35, 26, 24, 23, 52, 38, 49, 30, /* EX */
   64, 65, 41, 31, 33, 66, 40,SYM, 36, 50, 67, 47, 34, 68, 69, 70, /* FX */
};
/*X0  X1  X2  X3  X4  X5  X6  X7  X8  X9  XA  XB  XC  XD  XE  XF */

constexpr unsigned char Iso_8859_1_CharToOrderMap[] =
{
  CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,RET,CTR,CTR,RET,CTR,CTR, /* 0X */
  CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR, /* 1X */
  SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM, /* 2X */
  NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,SYM,SYM,SYM,SYM,SYM,SYM, /* 3X */
  SYM,  3, 16, 21,  8,  0, 20, 10, 18,  1, 22, 11,  9, 14,  2,  6, /* 4X */
   17, 29,  5,  4,  7, 13, 12, 15, 27, 19, 25,SYM,SYM,SYM,SYM,SYM, /* 5X */
  SYM,  3, 16, 21,  8,  0, 20, 10, 18,  1, 22, 11,  9, 14,  2,  6, /* 6X */
   17, 29,  5,  4,  7, 13, 12, 15, 27, 19, 25,SYM,SYM,SYM,SYM,CTR, /* 7X */
  CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR, /* 8X */
  CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR, /* 9X */
  SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM, /* AX */
  SYM,SYM,SYM,SYM,SYM, 88,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM, /* BX */
   48, 28, 45, 44, 43, 51, 42, 39, 35, 26, 24, 23, 52, 38, 49, 30, /* CX */
   89, 90, 41, 31, 33, 91, 40,SYM, 36, 50, 92, 47, 34, 93, 94, 46, /* DX */
   48, 28, 45, 44, 43, 51, 42, 39, 35, 26, 24, 23, 52, 38, 49, 30, /* EX */
   95, 96, 41, 31, 33, 97, 40,SYM, 36, 50, 98, 47, 34, 99,100,101, /* FX */
};
/*X0  X1  X2  X3  X4  X5  X6  X7  X8  X9  XA  XB  XC  XD  XE  XF */

constexpr unsigned char Iso_8859_9_CharToOrderMap[] =
{
  CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,RET,CTR,CTR,RET,CTR,CTR, /* 0X */
  CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR, /* 1X */
  SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM, /* 2X */
  NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,SYM,SYM,SYM,SYM,SYM,SYM, /* 3X */
  SYM,  3, 16, 21,  8,  0, 20, 10, 18,  1, 22, 11,  9, 14,  2,  6, /* 4X */
   17, 29,  5,  4,  7, 13, 12, 15, 27, 19, 25,SYM,SYM,SYM,SYM,SYM, /* 5X */
  SYM,  3, 16, 21,  8,  0, 20, 10, 18,  1, 22, 11,  9, 14,  2,  6, /* 6X */
   17, 29,  5,  4,  7, 13, 12, 15, 27, 19, 25,SYM,SYM,SYM,SYM,CTR, /* 7X */
  CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR, /* 8X */
  CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR, /* 9X */
  SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM, /* AX */
  SYM,SYM,SYM,SYM,SYM,102,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM, /* BX */
   48, 28, 45, 44, 43, 51, 42, 39, 35, 26, 24, 23, 52, 38, 49, 30, /* CX */
  103,104, 41, 31, 33,105, 40,SYM, 36, 50,106, 47, 34,107,108, 46, /* DX */
   48, 28, 45, 44, 43, 51, 42, 39, 35, 26, 24, 23, 52, 38, 49, 30, /* EX */
  109,110, 41, 31, 33,111, 40,SYM, 36, 50,112, 47, 34,113,114,115, /* FX */
};
/*X0  X1  X2  X3  X4  X5  X6  X7  X8  X9  XA  XB  XC  XD  XE  XF */

constexpr unsigned char Iso_8859_15_CharToOrderMap[] =
{
  CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,RET,CTR,CTR,RET,CTR,CTR, /* 0X */
  CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR, /* 1X */
  SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM,SYM, /* 2X */
  NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,SYM,SYM,SYM,SYM,SYM,SYM, /* 3X */
  SYM,  3, 16, 21,  8,  0, 20, 10, 18,  1, 22, 11,  9, 14,  2,  6, /* 4X */
   17, 29,  5,  4,  7, 13, 12, 15, 27, 19, 25,SYM,SYM,SYM,SYM,SYM, /* 5X */
  SYM,  3, 16, 21,  8,  0, 20, 10, 18,  1, 22, 11,  9, 14,  2,  6, /* 6X */
   17, 29,  5,  4,  7, 13, 12, 15, 27, 19, 25,SYM,SYM,SYM,SYM,CTR, /* 7X */
  CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR, /* 8X */
  CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR,CTR, /* 9X */
  SYM,SYM,SYM,SYM,SYM,SYM, 32,SYM, 32,SYM,SYM,SYM,SYM,SYM,SYM,SYM, /* AX */
  SYM,SYM,SYM,SYM, 37, 71,SYM,SYM, 37,SYM,SYM,SYM, 72, 73, 74,SYM, /* BX */
   48, 28, 45, 44, 43, 51, 42, 39, 35, 26, 24, 23, 52, 38, 49, 30, /* CX */
   75, 76, 41, 31, 33, 77, 40,SYM, 36, 50, 78, 47, 34, 79, 80, 46, /* DX */
   48, 28, 45, 44, 43, 51, 42, 39, 35, 26, 24, 23, 52, 38, 49, 30, /* EX */
   81, 82, 41, 31, 33, 83, 40,SYM, 36, 50, 84, 47, 34, 85, 86, 87, /* FX */
};
/*X0  X1  X2  X3  X4  X5  X6  X7  X8  X9  XA  XB  XC  XD  XE  XF */


/* Model Table:
 * Total sequences: 825
 * First 512 sequences: 0.9986034713711631
 * Next 512 sequences (512-1024): 0.0013965286288368912
 * Rest: -1.1709383462843448e-17
 * Negative sequences: TODO
 */
constexpr PRUint8 AfricaansLangModel[] =
{
  3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,
   3,0,3,0,2,3,2,2,0,2,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,
  3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,3,3,3,3,3,
   3,3,3,0,3,2,0,2,0,0,2,0,0,0,0,0,0,0,0,0,0,2,0,0,0,
  3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,3,
   3,3,2,3,2,0,2,0,0,0,2,0,0,0,2,0,2,0,0,0,0,0,0,0,0,
  3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,0,
   3,0,3,0,2,3,0,2,2,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,
  3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,3,
   3,2,0,0,2,0,2,0,0,2,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,
  3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,2,
   3,3,2,2,2,0,2,2,0,2,2,3,0,2,0,0,0,0,2,2,0,0,2,0,0,
  3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,
   3,2,3,0,2,2,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,
  3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,3,3,0,3,
   3,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,2,0,
  3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,3,0,3,
   3,3,0,2,2,0,0,0,2,2,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,
  3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,3,
   2,3,2,0,0,0,0,2,0,0,2,0,0,0,0,2,2,0,0,0,0,0,0,0,0,
  3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,0,2,
   2,2,0,0,0,0,2,0,0,2,2,0,0,0,0,2,0,0,0,0,0,0,0,0,0,
  3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,0,0,0,
   2,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,
  3,3,3,3,3,3,3,0,2,3,0,3,0,3,2,0,0,3,0,3,2,0,0,0,2,
   0,2,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,3,3,2,0,2,
   2,3,3,0,0,2,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,0,3,
   2,2,0,2,0,0,2,0,2,2,0,0,0,2,0,0,2,0,0,0,0,0,0,0,0,
  3,3,3,3,3,3,3,2,0,2,0,2,2,3,0,3,2,2,3,3,3,2,3,0,3,
   0,2,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  3,3,3,3,3,3,3,3,2,3,2,2,0,3,2,3,3,3,2,3,2,3,2,0,0,
   0,2,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,
  3,3,2,3,3,3,3,3,3,3,3,3,3,3,3,2,3,3,3,3,3,2,2,0,2,
   2,2,2,0,0,0,2,0,0,0,2,0,0,0,0,0,0,2,0,0,0,0,0,0,0,
  3,3,3,3,2,3,3,3,2,3,0,2,0,3,3,3,2,0,0,3,2,2,0,0,3,
   0,2,0,2,2,0,0,0,2,2,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,
  3,2,3,3,3,3,3,3,3,3,3,3,3,2,3,3,3,3,3,0,3,3,2,0,0,
   2,0,0,0,0,0,0,0,0,0,2,0,2,0,0,0,0,0,0,0,0,0,0,0,0,
  3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,0,0,
   0,2,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  3,3,2,3,3,3,3,3,2,3,0,3,0,3,2,2,2,0,3,3,2,3,2,0,0,
   3,0,0,0,3,0,2,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  3,3,2,3,0,2,3,2,2,2,0,2,0,3,3,2,2,2,2,2,0,2,0,0,0,
   2,0,0,0,0,0,2,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  2,3,3,0,3,3,0,3,2,3,2,0,2,0,2,0,2,0,0,0,2,0,0,0,0,
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  2,0,0,0,0,3,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
   0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  3,3,3,3,2,2,3,2,2,0,2,2,0,3,2,2,2,2,2,3,2,2,2,0,0,
   2,0,0,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  3,2,3,2,2,2,2,2,2,3,2,0,2,2,2,0,3,3,0,0,0,2,0,0,0,
   0,2,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  3,3,0,3,0,0,2,3,0,2,0,0,2,2,0,2,2,3,2,3,2,2,0,0,0,
   0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,2,0,2,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,
   0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,2,0,2,0,0,2,0,0,0,0,0,2,3,0,2,0,0,0,0,0,0,0,0,0,
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  2,0,3,0,3,2,0,2,2,2,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,2,2,0,0,2,0,0,2,2,2,0,0,0,2,2,0,0,0,0,2,0,0,0,0,
   2,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  2,2,0,2,0,2,0,3,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,2,0,0,2,0,3,0,0,0,0,0,0,2,0,0,2,0,0,0,0,0,0,0,
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,2,0,2,2,0,2,2,2,2,0,0,0,0,0,0,0,2,0,0,2,0,0,0,
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,2,2,0,2,2,0,0,0,2,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  2,2,0,0,0,0,0,0,2,0,0,2,2,0,0,0,0,0,0,2,0,0,0,0,0,
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,2,2,0,2,2,2,2,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,
   0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,2,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,2,2,0,2,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,2,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,2,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,2,0,0,0,0,2,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
};


const SequenceModel Windows_1252AfricaansModel =
{
  Windows_1252_CharToOrderMap,
  AfricaansLangModel,
  50,
  (float)0.9986034713711631,
  PR_TRUE,
  "WINDOWS-1252"
};

const SequenceModel Iso_8859_1AfricaansModel =
{
  Iso_8859_1_CharToOrderMap,
  AfricaansLangModel,
  50,
  (float)0.9986034713711631,
  PR_TRUE,
  "ISO-8859-1"
};

const SequenceModel Iso_8859_9AfricaansModel =
{
  Iso_8859_9_CharToOrderMap,
  AfricaansLangModel,
  50,
  (float)0.9986034713711631,
  PR_TRUE,
  "ISO-8859-9"
};

const SequenceModel Iso_8859_15AfricaansModel =
{
  Iso_8859_15_CharToOrderMap,
  AfricaansLangModel,
  50,
  (float)0.9986034713711631,
  PR_TRUE,
  "ISO-8859-15"
};
